POJ 3126 Prime Path 筛法+最短路

来源:互联网 发布:ubuntu好用的输入法 编辑:程序博客网 时间:2024/06/10 20:24

网上的题解都是用BFS求最短路的,我这里用了dijkstra,感觉功能太强了点。



Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 15553 Accepted: 8768

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source

Northwestern Europe 2006

#include<cstdio>#include<string>#include<cstring>#include<iostream>#include<cmath>#include<algorithm>#include<vector>#include<queue>using namespace std;typedef long long ll;const int INF =0x3f3f3f3f;const int maxn= 10000   ;bool vis[maxn+4];int dp[maxn+4];struct Edge{    int from,to;    Edge(){}    Edge(int from,int to):from(from),to(to){}};vector<Edge>edges;vector<int >G[maxn+5];struct Node{    int x,dis;    Node(){}    Node(int x,int dis):x(x),dis(dis){}    bool operator<(const Node y)const    {        return dis>y.dis;    }};bool done[maxn+4];void pre(){    for(int i=2;i*i<=maxn;i++) if(!vis[i])    {        for(int j=i*i;j<=maxn;j+=i)        {            vis[j]=1;        }    }}int st,ed;bool in(int x){    return 1000<=x&&x<=9999;}inline void add_edge(int x,int y){    edges.push_back(Edge(x,y) );    int m=edges.size();    G[x].push_back(m-1);}void dijkstra(){    memset(dp,0x3f,sizeof dp);    dp[st]=0;    memset(done,0,sizeof done);    priority_queue<Node>q;    q.push(Node(st,0));    while(!q.empty())    {        Node now=q.top();q.pop();        int x=now.x;        if(done[x])  continue;        done[x]=1;        if(x==ed)  return;//答案已出,可以结束了        int dis=now.dis;        for(int i=0;i<G[x].size();i++)        {            Edge e =edges[G[x][i]];//我晕,写掉了            int y=e.to;            if(done[y])  continue;            if(dis+1<dp[y])            {                dp[y]=dis+1;                q.push(Node(y ,dp[y]) );            }        }    }}void work(){    for(int i=1000;i<=9999;i++)    {            G[i].clear();    }    edges.clear();    for(int x=1000;x<=9999;x++)    {        int up=x/1000;        for(int i=0;i<=9;i++)        {            int y=x-up*1000+i*1000;            if(!in(y)||vis[y]||x==y)  continue;            add_edge(x,y);        }        up=x%1000/100;        for(int i=0;i<=9;i++)        {            int y=x-up*100+i*100 ;            if(!in(y)||vis[y]||x==y)  continue;            add_edge(x,y);        }         up=x%100/10;        for(int i=0;i<=9;i++)        {            int y=x-up*10+i*10;           if(!in(y)||vis[y]||x==y)  continue;            add_edge(x,y);        }            up=x%10;        for(int i=0;i<=9;i++)        {            int y=x-up+i;             if(!in(y)||vis[y]||x==y)  continue;             add_edge(x,y);        }    }    dijkstra();}int main(){    pre();    int T;scanf("%d",&T);    while(T--)    {        scanf("%d%d",&st,&ed);        work();        printf("%d\n",dp[ed]);    }   return 0;}


0 0
原创粉丝点击